////////////////////////////////////////////////////////////////////////////
// Modulo        : autosuggest.js
// Criado por    : Daniel Becker Bighelini
// Modificado em : 15/01/2016
// Objetivo      : Diversas modificacoes no funcionamento das sugestoes
////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 CA.  All rights reserved.
function generate_url(element_id)
{
var is_detail = false;
var extraQuery="";
var form_name_autoSuggest = "";
if((typeof propFormName3 == "string" && propFormName3 == "edit") || typeof __search_filter == "undefined")
is_detail = true;
var elem = document.getElementById(element_id);
if(typeof elem != "undefined" && elem != null)
form_name_autoSuggest = elem.form.name;
else if(is_detail)
{
if(typeof propFormName3 == "string" && propFormName3 == "edit")
form_name_autoSuggest = detailCurrForm();
else
form_name_autoSuggest = "main_form";
}
else
{
n = __search_filter.form.length - 1;
form_name_autoSuggest = "fltrForm"+n;
}
if(autosuggest_arr[element_id].is_contact)
{
var backfill_field = autosuggest_arr[element_id].backfill_field;
}
else
{
if(is_detail)
var backfill_field = 'KEY.'+autosuggest_arr[element_id].backfill_field;
else
var backfill_field = 'QBE.IN.' + autosuggest_arr[element_id].backfill_field;
}
if(is_detail) {
var f=_dtl.form[0];
// Alterado por Daniel Becker Bighelini
// Para sugerir os RESPONSAVEIS de acordo com o respectivo GRUPO informado
if ( backfill_field == "assignee" && typeof f.elements["SET.group"] == "object" && 
f.elements["SET.group"].value != "")
// Para sugerir os GRUPOS de acordo com o respectivo RESPONSAVEL informado
if ( backfill_field == "group" && typeof f.elements["SET.assignee"] == "object" && 
f.elements["SET.assignee"].value != "")
var extraQuery = "+ADDITIONAL_WHERE=(member_list.member=U'" + f.elements["SET.assignee"].value + "')";
} else { // Se estiver em formularios de pesquisa
	var f=ahdframe.document.forms["fltrForm0"];
}
// Para sugerir IC's observando mais de um campo
if ( autosuggest_arr[element_id].obj_type == "nr" && f.elements[backfill_field].value != "") {
	if (autosuggest_arr[element_id].extraURL == "") {
		var extraQuery = "+ADDITIONAL_WHERE=";
	} else { // Para evitar sobreescrever o extraURL do dtllookup
		var extraQuery = " AND ";
	}
	// Inclui os campos 'name' e 'system_name' nos criterios de procura
	extraQuery += "(name LIKE '%25" + f.elements[backfill_field].value + "%25' OR system_name LIKE '%25" + f.elements[backfill_field].value + "%25')";
}
// Fim da alteracao
var url_str = popup_search_text(autosuggest_arr[element_id].obj_type,backfill_field,form_name_autoSuggest,autosuggest_arr[element_id].extraURL,
autosuggest_arr[element_id].is_contact);
if( url_str != null && url_str.indexOf(extraQuery)== -1 && extraQuery!="")
url_str+=extraQuery;
url_str = initiate_autofill_text(url_str,autosuggest_arr[element_id].is_contact,form_name_autoSuggest,'',
backfill_field);	
url_str += "+numAutosuggestRecords="+ahdtop.propMaxRecordsAutoSuggest+"+common_name="+autosuggest_arr[element_id].common_name;	
return url_str;
}
function escape_special_chars( term )
{
term = term.replace(/#/g, "%23");
term = term.replace(/%/g, "%25");
term = term.replace(/&/g, "%26");
return encodeURIComponent(term);
}
function track_input(event)
{
var obj = jq("#" + this.id);
if (obj != null)
obj.autocomplete("search", this.value);
}
function appendAutoSuggestCode()
{
if (typeof autosuggest_arr != "undefined" && (typeof propFormName3 != "string" || propFormName3 != "ro"))
{
var item = "<SCR" + "IPT language=\"javascript\" type=\"text/javascript\">"
+"jq(document).ready(function() {";
for (element_id in autosuggest_arr)
{
if (!_browser.isIE && nonLatinFlag)
{
var obj = document.getElementById(element_id);
if (obj != null && obj.addEventListener != "undefined")
{
obj.addEventListener("input", track_input, false);
}	
}
var is_detail = false;
var onchg = "";
if((typeof propFormName3 == "string" && propFormName3 == "edit") || typeof __search_filter == "undefined")
is_detail = true;	
if(document.getElementById(element_id) != null)
onchg = document.getElementById(element_id).onchange;
if(onchg == "")
onchg = null;
// Definindo os parametros do autosuggest
if (autosuggest_arr[element_id].obj_type == "nr") {
	// Para sugerir IC's observando mais de um campo
	// A clausula de procura foi informada na variavel extraURL
	var zcomplemento = "jq.get(generate_url('"+element_id+"'),\"\",";
} else {
	// Para exibir a sugestao de pesquisa a partir de partes do texto digitado
	var zcomplemento = "jq.get(generate_url('"+element_id+"'),\""+ autosuggest_arr[element_id].autoComplete_parameter+"=%25\"+term+\"%25\",";
}
// Fim da alteracao
item += "var is_open = false; var called_chg = false;"
+"jq('#" + element_id + "').autocomplete({"	
+"source: function(request, response) {"
+"if("+is_detail+"){"
+"_dtl.is_from_autoSuggest = false;}"
+"else {"
+"__search_filter.is_from_autoSuggest = false;} "
+"var term = nx_escape(request.term);"	
// Alterado por Daniel Becker Bighelini
//+"jq.get(generate_url('"+element_id+"'),\""+ autosuggest_arr[element_id].autoComplete_parameter+"=\"+term+\"%25\","
+zcomplemento
// Fim da alteracao
+"function(data){"
+"data = data.substring(0, data.lastIndexOf(\"\\\n\")-1); try{data = jQuery.parseJSON(data);}catch(e){return \"\";}"	
+"return response(data);"
+"},\"html\");"
+"},"
+"open: function(event, ui) { "
+"tempKeyDownHandler = null;"
+"is_open = true;"
+"called_chg = false;"
+"document.getElementById('"+element_id+"').onchange = null;"
+"var widget = jq('#" + element_id + "').autocomplete('widget');"
+"if(jq('#" + element_id + "').autocomplete('widget').position().top < 0 || jq('#" + element_id + "').autocomplete('widget').position().left < 0)"
+"setTimeout(function() { checkAutocompletePosition(widget, jq('#" + element_id + "')); }, 0);"
+"},"
+"select: function(event, ui) { "
+ "var last_autoSuggest_value = null;"
+ "var last_autoSuggest_id = null;"
+ "if ( typeof ui != 'undefined' && typeof ui.item != 'undefined'           && "
+ "     typeof ui.item.value == 'string' && ui.item.value.length > 0 &&"
+ "     typeof ui.item.id    == 'string' && ui.item.id.length > 0 )"
+ "{"
+ "   last_autoSuggest_value = ui.item.value;"
+ "   last_autoSuggest_id    = ui.item.id;"
+ "}"
+"if("+is_detail+"){"
+ "if ( last_autoSuggest_value != null && last_autoSuggest_id != null )"
+ "{"
+ "   _dtl.last_autoSuggest_value = last_autoSuggest_value;"
+ "   _dtl.last_autoSuggest_id    = last_autoSuggest_id;"
+ "}"
+"_dtl.is_from_autoSuggest = 'SKIP_AUTO_FILL';}"
+"else{ "
+ "if ( last_autoSuggest_value != null && last_autoSuggest_id != null )"
+ "{"
+ "   if ( last_autoSuggest_value.length > 0 && last_autoSuggest_value.substr(last_autoSuggest_value.length-1,1) == \" \" )"
+ "      last_autoSuggest_value = last_autoSuggest_value.substr(0,last_autoSuggest_value.length-1) + \",\";"
+ "   __search_filter.last_autoSuggest_value = last_autoSuggest_value;"
+ "   __search_filter.last_autoSuggest_id    = last_autoSuggest_id;"
+ "}"
+ "__search_filter.is_from_autoSuggest = 'SKIP_AUTO_FILL';"
+ "add_percent_flds[document.getElementById('" + element_id + "').name] = 0;}"
+"},"
+"change: function(event, ui) { "
+"if("+is_detail+"){"
+"if(_dtl.is_from_autoSuggest != 'SKIP_AUTO_FILL'){"
+"if(is_open && called_chg == false) {"
+"document.getElementById('"+element_id+"').onchange = "+onchg+";"
+"document.getElementById('"+element_id+"').onchange();"
+"}"
+"}"	
+"}"
+"else {"
+"if(__search_filter.is_from_autoSuggest != 'SKIP_AUTO_FILL'){"
+"if(is_open && called_chg == false) {"
+"document.getElementById('"+element_id+"').onchange = "+onchg+";"
+"document.getElementById('"+element_id+"').onchange();"
+"}"
+"}"
+"}"
+"is_open = false;"	
+"},"
+"close: function(event, ui) {"
+"if("+is_detail+"){"
+"setTempKeyDownHandler(detailKeyDown);"
+"if(_dtl.is_from_autoSuggest == 'SKIP_AUTO_FILL') {"
+"document.getElementById('"+element_id+"').onchange = "+onchg+";"
+"document.getElementById('"+element_id+"').onchange();"
+"called_chg = true;"
+"}"
+"}"
+"else {"
+"setTempKeyDownHandler(searchFilterKeyDown);"
+"if(__search_filter.is_from_autoSuggest == 'SKIP_AUTO_FILL') {"
+"document.getElementById('"+element_id+"').onchange = "+onchg+";"
+"document.getElementById('"+element_id+"').onchange();"
+"called_chg = true;"
+"}"	
+"}"	
+"jq('#" + element_id + "').autocomplete('widget').css('max-height', '196px');"	
+"jq('#" + element_id + "').autocomplete('widget').width(0);"
+"},"	
+"minLength: "+ ahdtop.propMinCharsAutoSuggest
+"}"
+");";
}
item += "});" 
+"</SCR" + "IPT>";
docWriteln(item);
}
}
checkAutocompletePosition = function(inputObj, autoObj)
{
var offset = inputObj.position();
var heightComp = inputObj.outerHeight();
var widthComp = inputObj.outerWidth();
if(offset.top < 0) 
{
inputObj.css('max-height', (heightComp + offset.top - 8) + 'px');
inputObj.css('top', '2px');
}
if(offset.left < 0) 
{
var _left = autoObj.position().left - widthComp;
if(_left < 0)
_left = 2;
inputObj.css('left', _left);
}
};
